' **********************************************************
'  GenerateVerLinListTable
'
'  Generates a chart showing the amount of data and index
'  space used.
' **********************************************************

sub GenerateVerLinListTable(ByVal strPackageGuid)
	Dim iVersionNum
	Dim iVersionMax
	Dim iLinNum
	Dim iLinMax
	Dim arrVersions()
	Dim arrLineages()
	Dim arrLinPropValues()
	Dim strPackGuid
	Dim strVermodtime

	strHTML = "<table class=""DBTable"" width=""100%"" cellpadding=""0"" cellspacing=""2"">"

	Call findVersionGuids(arrVersions, strPackageGuid)

	iVersionMax = UBound(arrVersions) - 1
	For iVersionNum = 0 to iVersionMax
		Call getVersionName(strVersionName, arrVersions(iVersionNum))
		strPackGuid = getPackageGuidFromVers(arrVersions(iVersionNum))
		Call getPackageVermodtime(strVermodtime, strPackGuid)
		strVermodtime = GetResString(81) & strVermodtime
		strHTML = strHTML & GenerateVersionRow(strVersionName, strVermodtime, arrVersions(iVersionNum))
		Call findLineageGuids(arrLineages, arrVersions(iVersionNum))
		iLinMax = UBound(arrLineages) - 1
		For iLinNum = 0 to iLinMax
			Call getLinProperties(arrLinPropValues, arrLineages(iLinNum))
			strHTML = strHTML & GenerateLineageRow(arrLinPropValues, arrLineages(iLinNum))
		Next
	Next

	strHTML = strHTML & "</table>"
	document.all.BrowseTable.style.display = ""
	document.all.HorzRuleVerLin.style.display = ""

	document.all.VerLinListData.innerHTML = strHTML
end sub


Function GenerateVersionRow(strVersionName, strVermodtime, strVersionGuid)
	Dim strHTML
	strVersionName = MyHTMLEncode(strVersionName)
	strVermodtime = MyHTMLEncode(strVermodtime)

	strHTML = ""
	strHTML = strHTML & "<tr>"
	strHTML = strHTML & "  <td class=""DBHighlightedTableText"" width=""40%"">"
	strHTML = strHTML & "    <table frame=""void"" cellspacing=""0"" cellpadding=""0"" width=""100%"">"
	strHTML = strHTML & "      <tr>"
	strHTML = strHTML & "        <td width=""10"" nowrap></td>"
	strHTML = strHTML & "        <td class=""DBHighlightedTableText""><a class=""TableRowButton"" href language=""jscript"" onclick=""ShowPackFromVers(&quot;" & strVersionName & "&quot;, &quot;" & strVersionGuid & "&quot;)""><img src=""repver.gif"">&nbsp;" & strVermodtime & "</a></td>"
	strHTML = strHTML & "      </tr>"
	strHTML = strHTML & "	   </table>"
	strHTML = strHTML & "  </td>"
	strHTML = strHTML & "  <td class=""DBHighlightedTableText"">"
	strHTML = strHTML & "    <table frame=""void"" cellspacing=""0"" cellpadding=""0"" width=""100%"">"
	strHTML = strHTML & "	   </table>"
	strHTML = strHTML & "  </td>"
	strHTML = strHTML & "</tr>"
	GenerateVersionRow = strHTML
End Function


Function GenerateLineageRow(arrLinPropValues, strLineageGuid)
	Dim strHTML
	arrLinPropValues(0) = MyHTMLEncode(arrLinPropValues(0))
	arrLinPropValues(3) = MyHTMLEncode(arrLinPropValues(3))
	arrLinPropValues(4) = MyHTMLEncode(arrLinPropValues(4))
	arrLinPropValues(5) = MyHTMLEncode(arrLinPropValues(5))

	strHTML = ""
	strHTML = strHTML & "<tr>"
	strHTML = strHTML & "  <td class=""DBTableText"" width=""40%"">"
	strHTML = strHTML & "    <table frame=""void"" cellspacing=""0"" cellpadding=""0"" width=""100%"">"
	strHTML = strHTML & "      <tr>"
	strHTML = strHTML & "        <td width=""35"" nowrap></td>"
	strHTML = strHTML & "        <td class=""DBTableText""><a class=""TableRowButton"" href language=""jscript"" onclick=""ShowLinPackageProp(&quot;" & GetResString(83) & arrLinPropValues(0) & "&quot;,&quot;" & strLineageGuid & "&quot;)""><img src=""replin.gif"">&nbsp;" & GetResString(83) & arrLinPropValues(0) & "</a></td>"
	strHTML = strHTML & "      </tr>"
	strHTML = strHTML & "	   </table>"
	strHTML = strHTML & "  </td>"
	strHTML = strHTML & "  <td>"
	strHTML = strHTML & "    <table frame=""void"" cellspacing=""0"" cellpadding=""0"" width=""100%"">"
	strHTML = strHTML & "	     <td class=""DBTableText"" WIDTH=33% align=""left"">" & arrLinPropValues(3) & "</td>"
	strHTML = strHTML & "	     <td class=""DBTableText"" WIDTH=33% align=""left"">" & arrLinPropValues(4) & "</td>"
	strHTML = strHTML & "	     <td class=""DBTableText"" WIDTH=33% align=""left"">" & arrLinPropValues(5) & "</td>"
	strHTML = strHTML & "	   </table>"
	strHTML = strHTML & "  </td>"
	strHTML = strHTML & "</tr>"
	GenerateLineageRow = strHTML
End Function


'
Sub findAndShowLineage(ByVal LineageLong, ByVal LineageShort)
	Dim arrLinGuids()
	Dim strTitle
	
	Call findLinGuids(arrLinGuids, LineageLong, LineageShort)
	If (UBound(arrLinGuids) = 0) Then
		'lineage not found
		findLinMsg.innerText = GetResString(39)	' "Lineage Not Found."
	Else
		findLinMsg.innerText = ""
		If (LineageLong <> "") Then
			' use the LineageLong
			strTitle = GetResString(40)	& " = " & LineageLong		' "Lineage Long"
		Else
			' use the LineageShort
			strTitle = GetResString(41)	& " = " & LineageShort		' "Lineage Short"
		End if
		Call ShowLinsPackagesProp(strTitle, arrLinGuids)
	end if
end sub
